module Types (..) where

import Dict exposing (Dict)
import Time exposing (Time)


type alias BoardPos =
  ( Int, Int )


type alias Square =
  { isBomb : Bool
  , adjacentBombs : Int
  , isFlagged : Bool
  , isExposed : Bool
  , isExploded : Bool
  , isPressed : Bool
  }


type alias Board =
  Dict BoardPos Square


type alias Model =
  { board : Maybe Board
  , boardWidth : Int
  , boardHeight : Int
  , numBombs : Int
  , numFlags : Int
  , lost : Bool
  , numExposed : Int
  , startTime : Time
  , endTime : Time
  , generateNewBoard : Maybe BoardPos
  }


type Action
  = SmileyButtonPressed
  | Click ( Int, Int )
  | FlagClick ( Int, Int )
  | DifficultySelected ( Int, Int, Int )


type Smiley
  = SmileyNormal
  | SmileyClicking
  | SmileyWon
  | SmileyLost


won : Model -> Bool
won { boardWidth, boardHeight, numBombs, numExposed } =
  boardWidth * boardHeight - numBombs == numExposed
